function [A, B, C, D] = generate_example(exa_type, params);

switch exa_type
  case 'laplace_1d_01'
    n = params{1};
    m = params{2}

    A=diag(ones(n-1,1), 1)+diag(ones(n-1,1), -1)+eye(n)*(-2);
    A = A*1;
    B=zeros(n, m);
    C=zeros(m, n);
    D=zeros(m, m);

    MAX_SENSOR_SIZE = 0.4;

    if( m*MAX_SENSOR_SIZE > 1.0 )
      sensor_size = 1/m;
    else
      sensor_size = MAX_SENSOR_SIZE;
    end

    for i=1:m
      for j=1:n
        if( 1-i*sensor_size <= j/n && j/n <= 1-(i-1)*sensor_size )
           B(j, i) = sensor_function( (j/n-(1-i*sensor_size))/sensor_size );
        end

        if( (i-1)*sensor_size <= (j-1)/n && (j-1)/n <= i*sensor_size )
           C(i, j) = sensor_function( -((j-1)/n-(i)*sensor_size)/sensor_size );
        end
      end
    end

    C = C;

  otherwise
    error('Unkown example');
end

%
% defines a function with support in x \in [0, 1]
function s=sensor_function(x)

s = 10*x;
